local autopassOverride = {
	"INVTYPE_CLOAK",
}

local autopassTable = {
	["Cloth"]					= {"WARRIOR", "DEATHKNIGHT", "PALADIN", "DRUID", "MONK", "ROGUE", "HUNTER", "SHAMAN", "DEMONHUNTER"},
	["Leather"] 				= {"WARRIOR", "DEATHKNIGHT", "PALADIN", "HUNTER", "SHAMAN", "PRIEST", "MAGE", "WARLOCK"},
	["Mail"] 					= {"WARRIOR", "DEATHKNIGHT", "PALADIN", "DRUID", "MONK", "ROGUE", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Plate"]					= {"DRUID", "MONK", "ROGUE", "HUNTER", "SHAMAN", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Shields"] 				= {"DEATHKNIGHT", "DRUID", "MONK", "ROGUE", "HUNTER","PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Bows"] 					= {"DEATHKNIGHT", "PALADIN", "DRUID", "MONK", "SHAMAN", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Crossbows"] 				= {"DEATHKNIGHT", "PALADIN", "DRUID", "MONK", "SHAMAN", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Daggers"]					= {"WARRIOR", "DEATHKNIGHT", "PALADIN", "DRUID", "MONK", "HUNTER", },
	["Guns"]					= {"DEATHKNIGHT", "PALADIN", "DRUID", "MONK","SHAMAN", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Fist Weapons"] 			= {"DEATHKNIGHT", "PALADIN",  "PRIEST", "MAGE", "WARLOCK"},
	["One-Handed Axes"]			= {"DRUID", "ROGUE", "PRIEST", "MAGE", "WARLOCK"},
	["One-Handed Maces"]		= {"HUNTER", "MAGE", "WARLOCK"},
	["One-Handed Swords"] 		= {"DRUID", "SHAMAN", "PRIEST"},
	["Polearms"] 				= {"ROGUE", "SHAMAN", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Staves"]					= {"WARRIOR", "DEATHKNIGHT", "PALADIN",  "ROGUE", "DEMONHUNTER"},
	["Two-Handed Axes"]			= {"DRUID", "ROGUE", "MONK", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Two-Handed Maces"]		= {"MONK", "ROGUE", "HUNTER", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Two-Handed Swords"]		= {"DRUID", "MONK", "ROGUE", "SHAMAN", "PRIEST", "MAGE", "WARLOCK", "DEMONHUNTER"},
	["Wands"]					= {"WARRIOR", "DEATHKNIGHT", "PALADIN", "DRUID", "MONK", "ROGUE", "HUNTER", "SHAMAN", "DEMONHUNTER"},
	["Warglaives"]				= {"WARRIOR", "DEATHKNIGHT", "PALADIN", "DRUID", "MONK", "ROGUE", "PRIEST", "MAGE", "WARLOCK", "HUNTER", "SHAMAN",}
}

local relicTypes = {
	BLOOD     = 'Blood',
	SHADOW    = 'Shadow',
	IRON      = 'Iron',
	FROST     = 'Frost',
	FIRE      = 'Fire',
	FEL       = 'Fel',
	ARCANE    = 'Arcane',
	LIFE      = 'Life',
	STORM     = 'Wind',
	HOLY      = 'Holy'
}

local relics = {
	DEATHKNIGHT = {relicTypes.BLOOD, relicTypes.SHADOW,relicTypes.IRON,  relicTypes.FROST, relicTypes.FIRE },
	DEMONHUNTER = {relicTypes.FEL,   relicTypes.SHADOW,relicTypes.IRON,  relicTypes.ARCANE},
	DRUID       = {relicTypes.ARCANE,relicTypes.LIFE,  relicTypes.FIRE,  relicTypes.BLOOD, relicTypes.FROST},
	HUNTER      = {relicTypes.STORM, relicTypes.ARCANE,relicTypes.IRON,  relicTypes.BLOOD, relicTypes.LIFE},
	MAGE        = {relicTypes.ARCANE,relicTypes.FROST, relicTypes.FIRE},
	MONK        = {relicTypes.LIFE,  relicTypes.STORM, relicTypes.IRON,  relicTypes.FROST},
	PALADIN     = {relicTypes.HOLY,  relicTypes.LIFE,  relicTypes.FIRE,  relicTypes.IRON,  relicTypes.ARCANE},
	PRIEST      = {relicTypes.HOLY,  relicTypes.SHADOW,relicTypes.LIFE,  relicTypes.BLOOD},
	ROGUE       = {relicTypes.SHADOW,relicTypes.IRON,  relicTypes.BLOOD, relicTypes.STORM, relicTypes.FEL},
	SHAMAN      = {relicTypes.STORM, relicTypes.FROST, relicTypes.FIRE,  relicTypes.IRON,  relicTypes.LIFE},
	WARLOCK     = {relicTypes.SHADOW,relicTypes.BLOOD, relicTypes.FIRE,  relicTypes.FEL},
	WARRIOR     = {relicTypes.IRON,  relicTypes.BLOOD, relicTypes.SHADOW,relicTypes.FIRE,  relicTypes.STORM},
}


local RakijaAddonTestItemSet = 
{
	141293,141289,121109,121171,83793,121126
};

local RakijaAddonRollEnum =
{
	GREEN_FONT_COLOR_CODE.."Main Spec",
	ORANGE_FONT_COLOR_CODE.."Off Spec",
	GREYCOLORCODE.."Pass",
	GREYCOLORCODE.."AutoPass",
};

local RakijaAddon_LibItemUpgradeInfo = LibStub("LibItemUpgradeInfo-1.0");

RakijaDBLootTable = {};

function RakijaAddon_Loot_AutoPassCheck(link,playerClass)

	local _, _, _, _, _, _, subclass, _, equipSlot = GetItemInfo(link);

	if (not tContains(autopassOverride, equipSlot)) then
		if(equipSlot == "" and (subclass == "Artifact Relic"))then
			local itemID = GetItemIDFromLink(link);
			local relicType = select(3, C_ArtifactUI.GetRelicInfoByItemID(itemID));
			return (not tContains(relics[playerClass], relicType));
		elseif(subclass and autopassTable[subclass])then
			return tContains(autopassTable[subclass], playerClass);
		end
	end
	return false;
end

function RakijaAddon_Loot_LootOpened()
	RakijaLootFrame.lootOpend = true;
end

function RakijaAddon_Loot_LootClosed()
	RakijaLootFrame.lootOpend = false;
end

function RakijaAddon_Loot_GetSlotFromInvType(invType)

	if invType == "INVTYPE_HEAD" then
		return 1;
	elseif invType == "INVTYPE_SHOULDER" then
		return 3;
	elseif invType == "INVTYPE_CHEST" or invType == "INVTYPE_ROBE" then
		return 5;
	elseif invType == "INVTYPE_LEGS" then
		return 7;
	elseif invType == "INVTYPE_CLOAK" then
		return 15;
	elseif invType == "INVTYPE_FINGER" then
		return 11;
    elseif invType == "INVTYPE_TRINKET" then
    	return 13;
    elseif invType == "INVTYPE_NECK" then
    	return 2;
    elseif invType == "INVTYPE_FEET" then
    	return 8;
    elseif invType == "INVTYPE_WAIST" then
    	return 6;
    elseif invType == "INVTYPE_WRIST" then
    	return 9;
    elseif invType == "INVTYPE_HAND" then
    	return 10;
	end
	return -1;
end

function RakijaAddon_Loot_StartItemStream(messageArr,sender)
	table.wipe(RakijaDBLootTable);
	RakijaDBLootTable = {};
	RakijaDBLootTable.masterlooter = sender;
	RakijaDBLootTable.raiders = {};
	RakijaDBLootTable.items = {};

	for i=1,GetNumGroupMembers() do
		local name, _, _, _, class, fileName,_,_,_,_,_,role= GetRaidRosterInfo(i);
		RakijaDBLootTable.raiders[name] = {};
		RakijaDBLootTable.raiders[name].class = class;
		RakijaDBLootTable.raiders[name].fileName = fileName;
		RakijaDBLootTable.raiders[name].role = role;
		RakijaDBLootTable.raiders[name].itemRolls = {};
	end

end

function RakijaAddon_Loot_StoreItemCache(itemLink,itemIndex)

	RakijaDBLootTable.items[itemIndex] = {};
	RakijaDBLootTable.items[itemIndex].itemLink = itemLink;
	RakijaDBLootTable.items[itemIndex].autopass = false;
	RakijaDBLootTable.items[itemIndex].rolled = 0;
	RakijaDBLootTable.items[itemIndex].itemActuallIndex = itemIndex;

	local equipSlot = select(9,GetItemInfo(itemLink));
	local slot = RakijaAddon_Loot_GetSlotFromInvType(equipSlot);

	local currentItem1;

	if(equipSlot == "INVTYPE_TRINKET" or equipSlot == "INVTYPE_FINGER")then

		currentItem1 = GetInventoryItemLink("player",slot);
		local currentItem2 = GetInventoryItemLink("player",slot + 1);

		RakijaAddon_SendAddonMessage("CURITEM_LOOT",currentItem1.."\t"..itemIndex.."\t"..currentItem2,"RAID");

	elseif(equipSlot == "")then

		local itemID = GetItemIDFromLink(itemLink);
		local relicType = select(3, C_ArtifactUI.GetRelicInfoByItemID(itemID));
		local msg = "";

		for i=1,3 do
			local relic = RakijaDBChar.relicData[i];
			if(relic and relic.relicLink and (relic.relicType == relicType))then
				if(msg == "")then
					msg = relic.relicLink.."\t"..itemIndex;
				else
					msg = msg.."\t"..relic.relicLink;
				end
			end
		end

		if(msg == "")then
			RakijaAddon_SendAddonMessage("CURITEM_LOOT","NOSLOT".."\t"..itemIndex,"RAID");
		else
			RakijaAddon_SendAddonMessage("CURITEM_LOOT",msg,"RAID");
		end

	elseif(slot ~= -1)then
		currentItem1 = GetInventoryItemLink("player",slot);
		RakijaAddon_SendAddonMessage("CURITEM_LOOT",currentItem1.."\t"..itemIndex,"RAID");
	else
		RakijaAddon_SendAddonMessage("CURITEM_LOOT","NOSLOT".."\t"..itemIndex,"RAID");
	end
end

function RakijaAddon_Loot_StoreItemFromStream(messageArr,sender)
	local itemLink = messageArr[1];
	local itemIndex = tonumber(messageArr[2]);

	if(GetItemInfo(itemLink))then
		RakijaAddon_Loot_StoreItemCache(itemLink,itemIndex);
	else
		GetItemInfo_AddTask(itemLink,RakijaAddon_Loot_StoreItemCache,itemIndex);
	end
end

function RakijaAddon_Loot_EndItemStream()
	for i=1,#RakijaDBLootTable.items do
		if(RakijaAddon_Loot_AutoPassCheck(RakijaDBLootTable.items[i].itemLink,select(2,UnitClass("player"))))then
			RakijaDBLootTable.items[i].autopass = true;
			RakijaDBLootTable.items[i].rolled = 4;
			RakijaAddon_SendAddonMessage("CHOICE_LOOT",i.."\t"..4,"RAID");
		end
	end

	RakijaDBLootTable.lootReady = true;
	RakijaAddon_Loot_UpdateAll();
	RakijaAddon_openTab(3);
end

function RakijaAddon_Loot_SendLootRoll(itemIndex,roll)
	RakijaAddon_SendAddonMessage("CHOICE_LOOT",itemIndex.."\t"..roll,"RAID");
end

function RakijaAddon_Loot_RecivedLootRoll(messageArr,sender)
	local itemIndex = tonumber(messageArr[1]);
	local choice = tonumber(messageArr[2]);
	local name = Ambiguate(sender,"GUILD");

	if(not RakijaDBLootTable.raiders[name].itemRolls[itemIndex])then 
		RakijaDBLootTable.raiders[name].itemRolls[itemIndex] = {};
	end

	RakijaDBLootTable.raiders[name].itemRolls[itemIndex].rolled = choice;
	RakijaAddon_Loot_UpdateCurrentItem();
end

local function RakijaAddon_LootProcessCurrentItem(itemLink,itemIndex,sender,extraSlot)
	local name = Ambiguate(sender,"GUILD");

	local newILvl = RakijaAddon_LibItemUpgradeInfo:GetUpgradedItemLevel(RakijaDBLootTable.items[itemIndex].itemLink);
	local currIlvl1 = RakijaAddon_LibItemUpgradeInfo:GetUpgradedItemLevel(itemLink);
	
	if(not RakijaDBLootTable.raiders[name].itemRolls[itemIndex])then 
		RakijaDBLootTable.raiders[name].itemRolls[itemIndex] = {};
	end

	RakijaDBLootTable.raiders[name].itemRolls[itemIndex].itemActuallIndex = itemIndex;
	RakijaDBLootTable.raiders[name].itemRolls[itemIndex].rolled = 0;

	RakijaDBLootTable.raiders[name].itemRolls[itemIndex].currentItem1 = itemLink;

	if(itemLink ~= "NOSLOT")then
		RakijaDBLootTable.raiders[name].itemRolls[itemIndex].itemLvlDiff1 = newILvl - currIlvl1;

		if(extraSlot and extraSlot ~= "NOSLOT")then
			if(GetItemInfo(extraSlot))then
				local currIlvl2 = RakijaAddon_LibItemUpgradeInfo:GetUpgradedItemLevel(extraSlot);
				RakijaDBLootTable.raiders[name].itemRolls[itemIndex].currentItem2 = extraSlot;
				RakijaDBLootTable.raiders[name].itemRolls[itemIndex].itemLvlDiff2 = newILvl - currIlvl2;
			else
				GetItemInfo_AddTask(extraSlot,RakijaAddon_Loot_Recive2ndSlot,name,newILvl,itemIndex);
			end
		end
	end
end

function RakijaAddon_Loot_Recive2ndSlot(itemLink,name,newILvl,itemIndex)
	RakijaDBLootTable.raiders[name].itemRolls[itemIndex].currentItem2 = itemLink;
	RakijaDBLootTable.raiders[name].itemRolls[itemIndex].itemLvlDiff2 = newILvl - (RakijaAddon_LibItemUpgradeInfo:GetUpgradedItemLevel(itemLink));
end

function RakijaAddon_Loot_RecivedCurrentItem(messageArr,sender)
	local itemLink = messageArr[1];
	local itemIndex = tonumber(messageArr[2]);

	if(itemLink == "NOSLOT" or GetItemInfo(itemLink))then
		RakijaAddon_LootProcessCurrentItem(itemLink,itemIndex,sender,messageArr[3]);
	else
		GetItemInfo_AddTask(itemLink,RakijaAddon_LootProcessCurrentItem,itemIndex,sender,messageArr[3]);
	end

end

function RakijaAddon_Loot_StartLootSesion()
	local numItems = GetNumLootItems();

	RakijaAddon_SendAddonMessage("START_LOOT","","RAID");

	for i=1, numItems do
		local lootItemLink = GetLootSlotLink(i);
		local _, _, _, _, locked = GetLootSlotInfo(i);
		if(lootItemLink and (not locked))then
			RakijaAddon_SendAddonMessage("ITEM_LOOT",lootItemLink.."\t"..i,"RAID");
		end
	end

	RakijaAddon_SendAddonMessage("END_LOOT","","RAID");

end

function RakijaAddon_Loot_StartTestLootSesion()
	local numItems = #RakijaAddonTestItemSet;

	RakijaAddon_SendAddonMessage("START_LOOT","","RAID");

	for i=1, numItems do
		local _, lootItemLink = GetItemInfo(RakijaAddonTestItemSet[i]);
		if(lootItemLink)then
			RakijaAddon_SendAddonMessage("ITEM_LOOT",lootItemLink.."\t"..i,"RAID");
		end
	end

	RakijaAddon_SendAddonMessage("END_LOOT","","RAID");

end

function RakijaAddon_Loot_FindCorrectCandidateID(lootSlot,name)
	for playerIndex=1, GetNumGroupMembers() do
		local viableCandidateName = GetMasterLootCandidate(lootSlot,playerIndex);
		if(viableCandidateName == name)then
			return viableCandidateName;
		end
	end
	return;
end

function RakijaAddon_Loot_SendEndLootSession()
	RakijaAddon_SendAddonMessage("END_LOOTS","","RAID");
end

function RakijaAddon_Loot_EndLootSession()
	RakijaLootFrame.isRunning = false;
	RakijaDBLootTable = {};
	RakijaAddon_Loot_UpdateAll();
	--History

end

function RakijaAddon_Loot_onLoad(self)
	HybridScrollFrame_CreateButtons(RakijaLootList, "RakijaAddonLootListButtonTemplate", 0, 0, "TOPLEFT", "TOPLEFT", 0, 0, "TOP", "BOTTOM");
	RakijaLootList.update = RakijaAddon_Loot_UpdateChoiceButtons;
	RakijaLootListScrollBar.doNotHide = true;
end

function RakijaAddon_Loot_UpdateChoiceButtons()
	if(RakijaDBLootTable.lootReady)then
		local buttons = RakijaLootList.buttons;
		local numButtons = #buttons;

		local lootItems = RakijaDBLootTable.items;

		for i=1,numButtons do
			local button = buttons[i];
			local index = i + HybridScrollFrame_GetOffset(RakijaLootList);
			button.lootItemIndex = index;

			if(index == RakijaLootList.selectedButton)then

				button:LockHighlight();
			else
				button:UnlockHighlight();
			end

			local lootItem = lootItems[index];

			if(lootItem)then				
				
				button:Show();

				local name, _, quality, _, _, _, _, _, _, texture = GetItemInfo(lootItem.itemLink);

				button.itemLink.tooltipText = name;
				button.itemLink.hasItem = 1;
				button.itemLink.itemLink = lootItem.itemLink;
				button.itemLink.icon:SetTexture(texture);
				button.itemLink.IconBorder:Show();
				button.itemLink.IconBorder:SetVertexColor(BAG_ITEM_QUALITY_COLORS[quality].r, BAG_ITEM_QUALITY_COLORS[quality].g, BAG_ITEM_QUALITY_COLORS[quality].b);

				if(not lootItem.autopass or lootItem.awarded)then
					RakijaAddon_Loot_ItemButton_Enable(button);
				else
					RakijaAddon_Loot_ItemButton_Disable(button);
				end

				lastButtonIndex = i;
			else
				button:Hide();
			end
		end

		HybridScrollFrame_Update(RakijaLootList, #lootItems * 60 , numButtons * 60);
	else
		for i=1,#RakijaLootList.buttons do
			RakijaLootList.buttons[i]:Hide();
		end

		HybridScrollFrame_Update(RakijaLootList,0 , #RakijaLootList.buttons * 60);
	end
end

function RakijaAddon_Loot_ChoiceList_onLoad(self)
	HybridScrollFrame_CreateButtons(RakijaLootChoiceList, "RakijaAddonLootChoiceButtonTemplate", 0, 0, "TOPLEFT", "TOPLEFT", 0, 0, "TOP", "BOTTOM");
	RakijaLootChoiceList.update = RakijaAddon_Loot_UpdateCurrentItem;
	RakijaLootChoiceListScrollBar.doNotHide = true;
end

local function RakijaAddon_Loot_UpdateButton(raiderItem,button,index)

	local name, _, quality, _, _, _, _, _, _, texture = GetItemInfo(raiderItem["currentItem"..index]);

	button:Show();
	button.ilvl:Show();

	local itemDiffLevel = raiderItem["itemLvlDiff"..index];

	local colorCodeLevel = "";
	if(itemDiffLevel>0)then
		colorCodeLevel = GREEN_FONT_COLOR_CODE;
	elseif(itemDiffLevel == 0)then
		colorCodeLevel = ORANGE_FONT_COLOR_CODE;
	else
		colorCodeLevel = RED_FONT_COLOR_CODE;
	end

	button.ilvl:SetText(colorCodeLevel..itemDiffLevel);
	
	button.tooltipText = name;
	button.hasItem = 1;
	button.itemLink = raiderItem["currentItem"..index];
	button.icon:SetTexture(texture);
	button.IconBorder:Show();
	button.IconBorder:SetVertexColor(BAG_ITEM_QUALITY_COLORS[quality].r, BAG_ITEM_QUALITY_COLORS[quality].g, BAG_ITEM_QUALITY_COLORS[quality].b);

end

function RakijaAddon_Loot_UpdateCurrentItem()
	if(RakijaDBLootTable.lootReady and RakijaLootList.selectedButton)then

		local selectedItemIndex = RakijaLootList.selectedButton;
		local buttons = RakijaLootChoiceList.buttons;
		local numButtons = #buttons;
		local isML = IsMasterLooter();

		local raiders = RakijaAddon_GetSortedRaidersByIlvl();

		for i=1,numButtons do
			local button = buttons[i];
			local index = i + HybridScrollFrame_GetOffset(RakijaLootChoiceList);
			local raider = raiders[index];

			if(raider)then

				button:Show();

				if(isML)then
					button.awardButton:Enable();
				else
					button.awardButton:Disable();
				end

				button.icon:SetTexCoord(unpack(CLASS_ICON_TCOORDS[raider.fileName]));
				button.iconRole:SetTexCoord(GetTexCoordsForRole(raider.role));

				local classColor = RAID_CLASS_COLORS[raider.fileName];
				button.name:SetTextColor(classColor.r, classColor.g, classColor.b);
				button.name:SetText(raider.name);

				local raiderItem = raider.itemRolls[selectedItemIndex];

				if(raiderItem and raiderItem.currentItem1 ~= "NOSLOT")then

					RakijaAddon_Loot_UpdateButton(raiderItem,button.item1,1);

					if(raiderItem.rolled == 0)then
						button.choice:SetText("Waiting...");
					else
						button.choice:SetText(RakijaAddonRollEnum[raiderItem.rolled]);
					end
					

					if(raiderItem.currentItem2)then
						RakijaAddon_Loot_UpdateButton(raiderItem,button.item2,2);

					else
						button.item2:Hide();
					end

				else
					if(raiderItem and raiderItem.currentItem1 == "NOSLOT")then
						button.choice:SetText(RakijaAddonRollEnum[raiderItem.rolled]);
					else
						button.choice:SetText(RED_FONT_COLOR_CODE.."DC/NO ADDON?");
					end
					
					button.item1:Hide();
					button.item2:Hide();
				end

			else
				button:Hide();
			end

		end

		HybridScrollFrame_Update(RakijaLootChoiceList, 40 * #raiders , #RakijaLootChoiceList.buttons * 40)

	else

		for i=1,#RakijaLootChoiceList.buttons do
			RakijaLootChoiceList.buttons[i]:Hide();
		end

		HybridScrollFrame_Update(RakijaLootChoiceList, 0 , #RakijaLootChoiceList.buttons * 40);
	end
end

function RakijaAddon_Loot_UpdateHistory()
	-- body
end

function RakijaAddon_Loot_onStartStopClicked(self,isTest)

	if(isTest and (not RakijaLootFrame.isRunning))then
		RakijaLootFrame.isRunning = true;
		RakijaAddon_Loot_StartTestLootSesion();
		self:SetText("Stop Test Loot");
		message("Loot krece za 5 sec!","Becouse Reasons!");
		return;
	elseif(isTest and RakijaLootFrame.isRunning)then
		RakijaAddon_Loot_SendEndLootSession()
		self:SetText("Start Test Loot");
		return;
	end

	if(RakijaLootFrame.lootOpend and (not RakijaLootFrame.isRunning))then
		RakijaLootFrame.isRunning = true;
		RakijaAddon_Loot_StartLootSesion();
		message("Loot krece za 5 sec!");
		self:SetText("Stop Loot");
	elseif(RakijaLootFrame.isRunning)then
		RakijaAddon_Loot_SendEndLootSession()
		self:SetText("Start Loot");
	elseif((not RakijaLootFrame.lootOpend) and (not RakijaLootFrame.isRunning))then
		message("Otvori loot prvo!");
	end

end
