function RakijaAddon_RaidListing_onLoad(self)
	HybridScrollFrame_CreateButtons(RakijaRaidPlayerList, "RakijaAddonRaidPlayersButtonTemplate", 5, 0, "TOPLEFT", "TOPLEFT", 0, 0, "TOP", "BOTTOM");
	RakijaRaidPlayerListScrollBar.doNotHide = true;
	RakijaRaidPlayerList.update = RakijaAddon_RaidListing_Update;
end

function RakijaAddon_RaidSettings_onLoad(self)
	self.foodCheckBox:Disable();
	self.flaskCheckbox:Disable();
	self.runeCheckBox:Disable();
end

function RakijaAddon_RaidListing_onShow(self)
	RakijaAddon_RaidListing_Update();
end

function RakijaAddon_RaidListing_Update()
	local buttons = RakijaRaidPlayerList.buttons;
	local raidCount = GetNumGroupMembers();
	local numButtons = #buttons;

	for i=1, numButtons do

		local index = i + HybridScrollFrame_GetOffset(RakijaRaidPlayerList);
		local button = buttons[i];

		if((index <= raidCount) and (raidCount ~= 0))then

			button:Show();

			local raidDescriptor = RakijaAddon_GetGroupDiscriptor(index);
			local class, classFileName = UnitClass(raidDescriptor);

			local name,fullName = GetCurrentPlayerFullName(raidDescriptor);

			local isVisible = UnitIsVisible(raidDescriptor);
			local role = UnitGroupRolesAssigned(raidDescriptor);
			local buffs = RakijaAddon_GetUnitBuffs(raidDescriptor);

			button.classIcon:SetTexCoord(unpack(CLASS_ICON_TCOORDS[classFileName]));
			button.roleIcon:SetTexCoord(GetTexCoordsForRole(role));

			local classColor = RAID_CLASS_COLORS[classFileName];
			button.name:SetTextColor(classColor.r, classColor.g, classColor.b);
			button.name:SetText(name);

			if(isVisible)then
				button.inRangeIcon:SetTexture(READY_CHECK_READY_TEXTURE);
			else
				button.inRangeIcon:SetTexture(READY_CHECK_NOT_READY_TEXTURE);
			end

			if(RakijaDB.guildMembers[fullName])then
				button.dcIcon:SetTexture(READY_CHECK_READY_TEXTURE);
			else
				button.dcIcon:SetTexture(READY_CHECK_NOT_READY_TEXTURE);
			end

			RakijaAddon_SetFoodBuff(buffs,button);
			RakijaAddon_SetFlaskBuff(buffs,button);
			RakijaAddon_SetRuneBuff(buffs,button);
			RakijaAddon_SetVantusBuff(buffs,button);

		else
			button:Hide();
		end
	end

	local totalHeight = raidCount * 50;
	local displayedHeight = numButtons * 50;
	HybridScrollFrame_Update(RakijaRaidPlayerList, totalHeight, displayedHeight);

end

function RakijaAddon_SetVantusBuff(buffs,button)
	local shouldReset = true;
	for i,v in pairs(buffs) do
		if(RAKIJA_VANTUS_BUFFS[v.spellID])then
			_G[button.vantusBuff:GetName().."Icon"]:SetTexture(v.icon);
			button.vantusBuff.spellID = v.spellID;
			button.vantusBuff.buffDisplay:SetText(GREEN_FONT_COLOR_CODE..RAKIJA_VANTUS_BUFFS[v.spellID])
			shouldReset = false;
			break;
		end
	end

	if(shouldReset)then
		RakijaAdddon_RaidListing_ResetButtn(button.vantusBuff);
	end
end

function RakijaAddon_SetFoodBuff(buffs,button)
	local shouldReset = true;
	for i,v in pairs(buffs) do
		if(RAKIJA_FOOD_BUFFS[v.spellID])then
			_G[button.foodBuff:GetName().."Icon"]:SetTexture(v.icon);
			button.foodBuff.spellID = v.spellID;
			button.foodBuff.buffDisplay:SetText(GREEN_FONT_COLOR_CODE..RAKIJA_FOOD_BUFFS[v.spellID])
			shouldReset = false;
			break;
		end
	end

	if(shouldReset)then
		RakijaAdddon_RaidListing_ResetButtn(button.foodBuff);
	end
end

function RakijaAddon_SetFlaskBuff(buffs,button)
	local shouldReset = true;
	for i,v in pairs(buffs) do
		if(RAKIJA_FLASK_BUFFS[v.spellID])then
			_G[button.flaskBuff:GetName().."Icon"]:SetTexture(v.icon);
			button.flaskBuff.spellID = v.spellID;
			button.flaskBuff.buffDisplay:SetText(GREEN_FONT_COLOR_CODE..RAKIJA_FLASK_BUFFS[v.spellID])
			shouldReset = false;
			break;
		end
	end

	if(shouldReset)then
		RakijaAdddon_RaidListing_ResetButtn(button.flaskBuff);
	end
end

function RakijaAddon_SetRuneBuff(buffs,button)
	if(buffs[RAKIJA_RUNE_BUFF])then
		_G[button.runeBuff:GetName().."Icon"]:SetTexture(buffs[RAKIJA_RUNE_BUFF].icon);
		button.runeBuff.spellID = buffs[RAKIJA_RUNE_BUFF].spellID;
		button.runeBuff.buffDisplay:SetText(GREEN_FONT_COLOR_CODE.."325");
	else
		RakijaAdddon_RaidListing_ResetButtn(button.runeBuff);
	end
end

function RakijaAdddon_RaidListing_ResetButtn(button)
	button.spellID = nil;
	button.buffDisplay:SetText(" ");
	_G[button:GetName().."Icon"]:SetTexture("Interface\\ICONS\\INV_Misc_QuestionMark");
end

function RakijaAddon_AuraUpdate(self)
	if(self:IsShown())then
		RakijaAddon_RaidListing_Update();
	end
end

function RakijaAddon_RaidListing_buffOnEnter(self)
	if(self.spellID)then
		GameTooltip:SetOwner(self,"ANCHOR_BOTTOM");
		GameTooltip:SetSpellByID(self.spellID);
		GameTooltip:Show();
	end
end

function RakijaAddon_RaidListing_buffOnLeave(self)
	GameTooltip:Hide()
end
