local RakijaAddon_SchedulerDB = {};
RakijaAddon_SchedulerDB.totalTime = 0;
RakijaAddon_SchedulerDB.events = {};
RakijaAddon_SchedulerDB.corutines = {};

local pairs = pairs;

function RakijaAddon_Scheduler_Create()
	RakijaAddon_SchedulerDB.timerFrame = CreateFrame("frame");
	RakijaAddon_SchedulerDB.timerFrame:SetScript("onUpdate", RakijaAddon_Scheduler_OnUpdate);
end

function RakijaAddon_Scheduler_AddEvent(eventName,execInterval,func,persistant,arg1,arg2,arg3,arg4)

	local event = 
	{
		lastExecTime = RakijaAddon_SchedulerDB.totalTime;
		func = func;
		execInterval = execInterval;
		persistant = persistant;
		arg1 = arg1;
		arg2 = arg2;
		arg3 = arg3;
		arg4 = arg4;
	};
	
	RakijaAddon_SchedulerDB.events[eventName] = event;
end

function RakijaAddon_Scheduler_RemoveEvent(eventName)
	if(RakijaAddon_SchedulerDB.events[eventName])then
		RakijaAddon_SchedulerDB.events[eventName] = nil;
	end
end

function RakijaAddon_Scheduler_OnUpdate(self,dt)
	for k,event in pairs(RakijaAddon_SchedulerDB.events) do
		if(RakijaAddon_SchedulerDB.totalTime > (event.lastExecTime + event.execInterval))then

			if(event.arg1)then
				event.func(event.arg1,event.arg2,event.arg3,event.arg4,RakijaAddon_SchedulerDB.totalTime,dt,k);
			else
				event.func(RakijaAddon_SchedulerDB.totalTime,dt,k);
			end
			event.lastExecTime = RakijaAddon_SchedulerDB.totalTime;

			if(not event.persistant)then
				RakijaAddon_Scheduler_RemoveEvent(k);
			end

		end
	end

	RakijaAddon_SchedulerDB.totalTime = RakijaAddon_SchedulerDB.totalTime + dt;
end
